<?php

namespace HCM\FPA\Calculos\Geral;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\FPA\Entity\FpaeventohEntity;
use HCM\Geral\Entity\GpevinculohEntity;

class ContribuicaoSindical{

    public static function calcula(
        $evento, $mes_competencia, $item_de_calculo, $assoc_evento,
        $eventom, $vinculo
    ){
        $id_contribuicao_sindical = $vinculo->historico->getIdcontribuisind();
        $desconto = false;

        switch($id_contribuicao_sindical){
        case GpevinculohEntity::IDCONTRIBUISIND_DESCONTOU:
        case GpevinculohEntity::IDCONTRIBUISIND_NUNCA:
                return;
        case GpevinculohEntity::IDCONTRIBUISIND_SEMPRE:
                $dt_admissao = $vinculo->getDtadmissaovinc();
                $data_corrente = $mes_competencia;
                $mes = $data_corrente->format('m');
                $dt_mes_anterior = DateUtil::subtraiIntervalo($data_corrente, 1, DateUtil::MES);
            
            if (($mes === 3) && ($dt_admissao < $data_corrente)) {
                $desconto = true;
            } elseif (($mes === 1) && ($dt_admissao > $dt_mes_anterior)
                                   && ($dt_admissao < $data_corrente)) {
                $desconto = true;
            } elseif (($mes >= 4) && ($dt_admissao > $dt_mes_anterior)
                                 && ($dt_admissao < $data_corrente)) {
                $desconto = true;
            } else {
                $desconto = false;
            }

            if ($desconto === true) {
                $nrevento =  $assoc_evento->retornaEvento($evento, $vinculo->getNrorg());
                $evento_contrib_sind = $eventom->retornaEvento($nrevento);

                if ($evento_contrib_sind->historico->getIdunidrefereven() !== FpaeventohEntity::IDUNIDREFEREVEN_DIA) {
                    MsgCalculo::getInstance()->adicionaMensagem('Referência de contribuicao sindical precisa ser dia.');
                }
                $referencia = 1;
                $item_de_calculo->geraEvento($evento_contrib_sind, null, 0, $referencia, 1);
            }
            break;
        }
    }

}