<?php

namespace HCM\PTO\Controllers;

use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO;
use HCM\PTO\Services\RoteiroParamFrequenciaService;
use HCM\Util\Messages;
use HCM\Util\DateUtil;
use HCM\Util\HCMParameters;

class RoteiroParamFrequenciaController {

    public function __construct (Manager $dataSourceManager, ParameterBag $parameterBag, RoteiroParamFrequenciaService $roteiroParamFrequenciaService, HCMParameters $hcmParameters){
        $this->parameterBag                     = $parameterBag;
        $this->roteiroParamFrequenciaService    = $roteiroParamFrequenciaService;
        $this->hcmParameters                    = $hcmParameters;
    }
    
    public function setRoteiroParamFrequencia(DTO\Request\Row $request, DTO\Response $response){
        try{
            $row = $request->getRow()->getArrayCopy();
            
            $success = $this->roteiroParamFrequenciaService->setRoteiroParamFrequencia($row);
            
            $dataSet = array('success' => $success);
            
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('data', $dataSet));
        } catch(\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }
}